diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/utils/ipv6-address.cc ns-3.38/src/network/utils/ipv6-address.cc
--- ns-3.37/src/network/utils/ipv6-address.cc	2022-11-01 17:37:24.695395700 -0700
+++ ns-3.38/src/network/utils/ipv6-address.cc	2023-03-16 20:54:23.808869100 -0700
@@ -17,28 +17,6 @@
  * Author: Sebastien Vincent <vincent@clarinet.u-strasbg.fr>
  */
 
-// Part of the Ipv6Address::Print function has been adapted from inet_ntop6 Linux function.
-// See http://www.net-snmp.org/dev/agent/inet__ntop_8c_source.html
-// Author: Paul Vixie, 1996.
-// The inet_ntop6 function was under the copyright below, which is
-// compatible with GPLv2, see http://www.gnu.org/licenses/license-list.html#GPLCompatibleLicenses.
-
-/* Copyright (c) 1996 by Internet Software Consortium.
- *
- * Permission to use, copy, modify, and distribute this software for any
- * purpose with or without fee is hereby granted, provided that the above
- * copyright notice and this permission notice appear in all copies.
- *
- * THE SOFTWARE IS PROVIDED "AS IS" AND INTERNET SOFTWARE CONSORTIUM DISCLAIMS
- * ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES
- * OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL INTERNET SOFTWARE
- * CONSORTIUM BE LIABLE FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL
- * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR
- * PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS
- * ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
- * SOFTWARE.
- */
-
 #include "ipv6-address.h"
 
 #include "mac16-address.h"
@@ -49,7 +27,13 @@
 #include "ns3/log.h"
 
 #include <iomanip>
-#include <memory.h>
+#include <memory>
+
+#ifdef __WIN32__
+#include <WS2tcpip.h>
+#else
+#include <arpa/inet.h>
+#endif
 
 namespace ns3
 {
@@ -165,151 +149,6 @@
 }
 #endif
 
-/**
- * \brief Convert an IPv6 C-string into a 128-bit representation.
- *
- * \param address pointer to the char buffer with the address ascii representation
- * \param addr the buffer to store the IPv6 address
- *
- * \return true if success, false otherwise (bad format, ...)
- *
- * \note This function is strongly inspired by inet_pton6() from Paul Vixie.
- * \todo Handle IPv6 address with decimal value for last four bytes.
- */
-static bool
-AsciiToIpv6Host(const char* address, uint8_t addr[16])
-{
-    NS_LOG_FUNCTION(address << &addr);
-    static const char xdigits_l[] = "0123456789abcdef";
-    static const char xdigits_u[] = "0123456789ABCDEF";
-    unsigned char tmp[16];
-    unsigned char* tp = tmp;
-    unsigned char* const endp = tp + 16;
-    unsigned char* colonp = nullptr;
-    const char* xdigits = nullptr;
-#if 0
-  const char* curtok = 0;
-#endif
-    int ch = 0;
-    int seen_xdigits = 0;
-    unsigned int val = 0;
-
-    memset(tp, 0x00, 16);
-
-    /* Leading :: requires some special handling. */
-    if (*address == ':')
-    {
-        if (*++address != ':')
-        {
-            return (0);
-        }
-    }
-#if 0
-  curtok = address;
-#endif
-    while ((ch = *address++) != '\0')
-    {
-        const char* pch = nullptr;
-
-        if ((pch = strchr((xdigits = xdigits_l), ch)) == nullptr)
-        {
-            pch = strchr((xdigits = xdigits_u), ch);
-        }
-
-        if (pch != nullptr)
-        {
-            val <<= 4;
-            val |= (pch - xdigits);
-
-            if (++seen_xdigits > 4)
-            {
-                return (0);
-            }
-            continue;
-        }
-        if (ch == ':')
-        {
-#if 0
-          curtok = address;
-#endif
-
-            if (!seen_xdigits)
-            {
-                if (colonp)
-                {
-                    return (0);
-                }
-                colonp = tp;
-                continue;
-            }
-
-            if (endp - tp < 2)
-            {
-                return (0);
-            }
-
-            *tp++ = (unsigned char)(val >> 8) & 0xff;
-            *tp++ = (unsigned char)val & 0xff;
-            seen_xdigits = 0;
-            val = 0;
-            continue;
-        }
-
-        /* \todo Handle IPv4 mapped address (2001::192.168.0.1) */
-#if 0
-      if (ch == '.' && (endp - tp > 3 /* NS_INADDRSZ - 1 */)) &&
-          inet_pton4 (curtok, tp) > 0)
-        {
-          tp += 4 /*NS_INADDRSZ*/;
-          seen_xdigits = 0;
-          break; /* '\0' was seen by inet_pton4(). */
-        }
-#endif
-        return (0);
-    }
-
-    if (seen_xdigits)
-    {
-        if (endp - tp < 2)
-        {
-            return (0);
-        }
-        *tp++ = (unsigned char)(val >> 8) & 0xff;
-        *tp++ = (unsigned char)val & 0xff;
-    }
-
-    if (colonp != nullptr)
-    {
-        /*
-         * Since some memmove ()'s erroneously fail to handle
-         * overlapping regions, we'll do the shift by hand.
-         */
-        const int n = tp - colonp;
-        int i = 0;
-
-        if (tp == endp)
-        {
-            return (0);
-        }
-
-        for (i = 1; i <= n; i++)
-        {
-            endp[-i] = colonp[n - i];
-            colonp[n - i] = 0;
-        }
-
-        tp = endp;
-    }
-
-    if (tp != endp)
-    {
-        return (0);
-    }
-
-    memcpy(addr, tmp, 16);
-    return (1);
-}
-
 Ipv6Address::Ipv6Address()
 {
     NS_LOG_FUNCTION(this);
@@ -334,7 +173,14 @@
 Ipv6Address::Ipv6Address(const char* address)
 {
     NS_LOG_FUNCTION(this << address);
-    AsciiToIpv6Host(address, m_address);
+
+    if (inet_pton(AF_INET6, address, m_address) <= 0)
+    {
+        memset(m_address, 0x00, 16);
+        NS_LOG_LOGIC("Error, can not build an IPv6 address from an invalid string: " << address);
+        m_initialized = false;
+        return;
+    }
     m_initialized = true;
 }
 
@@ -356,7 +202,13 @@
 Ipv6Address::Set(const char* address)
 {
     NS_LOG_FUNCTION(this << address);
-    AsciiToIpv6Host(address, m_address);
+    if (inet_pton(AF_INET6, address, m_address) <= 0)
+    {
+        memset(m_address, 0x00, 16);
+        NS_LOG_LOGIC("Error, can not build an IPv6 address from an invalid string: " << address);
+        m_initialized = false;
+        return;
+    }
     m_initialized = true;
 }
 
@@ -389,22 +241,24 @@
 Ipv6Address::MakeIpv4MappedAddress(Ipv4Address addr)
 {
     NS_LOG_FUNCTION(addr);
-    uint8_t buf[16] = {0x00,
-                       0x00,
-                       0x00,
-                       0x00,
-                       0x00,
-                       0x00,
-                       0x00,
-                       0x00,
-                       0x00,
-                       0x00,
-                       0xff,
-                       0xff,
-                       0x00,
-                       0x00,
-                       0x00,
-                       0x00};
+    uint8_t buf[16] = {
+        0x00,
+        0x00,
+        0x00,
+        0x00,
+        0x00,
+        0x00,
+        0x00,
+        0x00,
+        0x00,
+        0x00,
+        0xff,
+        0xff,
+        0x00,
+        0x00,
+        0x00,
+        0x00,
+    };
     addr.Serialize(&buf[12]);
     return (Ipv6Address(buf));
 }
@@ -678,93 +532,12 @@
 {
     NS_LOG_FUNCTION(this << &os);
 
-    // note: part of this function has been adapted from inet_ntop6 Linux function.
-    // See http://www.net-snmp.org/dev/agent/inet__ntop_8c_source.html
-    // Author: Paul Vixie, 1996.
-
-    if (IsIpv4MappedAddress())
-    {
-        os << "::ffff:" << (unsigned int)m_address[12] << "." << (unsigned int)m_address[13] << "."
-           << (unsigned int)m_address[14] << "." << (unsigned int)m_address[15];
-        return;
-    }
-
-    uint16_t address[8];
-    uint8_t i;
-
-    for (i = 0; i < 8; i++)
-    {
-        address[i] = (uint16_t(m_address[2 * i]) << 8) | uint16_t(m_address[2 * i + 1]);
-    }
-
-    int8_t bestBase = -1;
-    int8_t bestLen = 0;
-    int8_t curBase = -1;
-    int8_t curLen = 0;
-
-    for (i = 0; i < 8; i++)
-    {
-        if (address[i] == 0)
-        {
-            if (curBase == -1)
-            {
-                curBase = i;
-                curLen = 1;
-            }
-            else
-            {
-                curLen++;
-            }
-        }
-        else
-        {
-            if (curBase != -1)
-            {
-                if (bestBase == -1 || curLen > bestLen)
-                {
-                    bestBase = curBase;
-                    bestLen = curLen;
-                }
-                curBase = -1;
-            }
-        }
-    }
-    if (curBase != -1)
-    {
-        if (bestBase == -1 || curLen > bestLen)
-        {
-            bestBase = curBase;
-            bestLen = curLen;
-        }
-    }
-    if (bestBase != -1 && bestLen < 2)
-    {
-        bestBase = -1;
-    }
+    char str[INET6_ADDRSTRLEN];
 
-    for (i = 0; i < 8;)
+    if (inet_ntop(AF_INET6, m_address, str, INET6_ADDRSTRLEN))
     {
-        // Are we inside the best run of 0x00's?
-        if (i == bestBase)
-        {
-            os << ':';
-            i += bestLen;
-            continue;
-        }
-        // Are we following an initial run of 0x00s or any real hex?
-        if (i != 0)
-        {
-            os << ':';
-        }
-        os << std::hex << (unsigned int)address[i];
-        i++;
-    }
-    // Was it a trailing run of 0x00's?
-    if (bestBase != -1 && (bestBase + bestLen) == 8)
-    {
-        os << ':';
+        os << str;
     }
-    os << std::dec;
 }
 
 bool
@@ -1044,7 +817,10 @@
 Ipv6Prefix::Ipv6Prefix(const char* prefix)
 {
     NS_LOG_FUNCTION(this << prefix);
-    AsciiToIpv6Host(prefix, m_prefix);
+    if (inet_pton(AF_INET6, prefix, m_prefix) <= 0)
+    {
+        NS_ABORT_MSG("Error, can not build an IPv6 prefix from an invalid string: " << prefix);
+    }
     m_prefixLength = GetMinimumPrefixLength();
 }
 
@@ -1058,8 +834,10 @@
 Ipv6Prefix::Ipv6Prefix(const char* prefix, uint8_t prefixLength)
 {
     NS_LOG_FUNCTION(this << prefix);
-    AsciiToIpv6Host(prefix, m_prefix);
-
+    if (inet_pton(AF_INET6, prefix, m_prefix) <= 0)
+    {
+        NS_ABORT_MSG("Error, can not build an IPv6 prefix from an invalid string: " << prefix);
+    }
     uint8_t autoLength = GetMinimumPrefixLength();
     NS_ASSERT_MSG(autoLength <= prefixLength,
                   "Ipv6Prefix: address and prefix are not compatible: " << Ipv6Address(prefix)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/utils/llc-snap-header.h ns-3.38/src/network/utils/llc-snap-header.h
--- ns-3.37/src/network/utils/llc-snap-header.h	2022-11-01 17:37:24.695395700 -0700
+++ ns-3.38/src/network/utils/llc-snap-header.h	2023-03-16 20:54:23.808869100 -0700
@@ -29,7 +29,7 @@
 {
 
 /**
- * The length in octects of the LLC/SNAP header
+ * The length in octets of the LLC/SNAP header
  */
 static const uint16_t LLC_SNAP_HEADER_LENGTH = 8;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/utils/mac8-address.h ns-3.38/src/network/utils/mac8-address.h
--- ns-3.37/src/network/utils/mac8-address.h	2022-11-01 17:37:24.695395700 -0700
+++ ns-3.38/src/network/utils/mac8-address.h	2023-03-16 20:54:23.808869100 -0700
@@ -63,6 +63,13 @@
     static Mac8Address ConvertFrom(const Address& address);
 
     /**
+     * Convert to a generic Address.
+     *
+     * \return The Address value.
+     */
+    Address ConvertTo() const;
+
+    /**
      * Check that a generic Address is compatible with Mac8Address.
      *
      * \param address  Address to test.
@@ -133,12 +140,6 @@
      * \return The type value.
      */
     static uint8_t GetType();
-    /**
-     * Convert to a generic Address.
-     *
-     * \return The Address value.
-     */
-    Address ConvertTo() const;
 
     friend bool operator<(const Mac8Address& a, const Mac8Address& b);
     friend bool operator==(const Mac8Address& a, const Mac8Address& b);
@@ -158,7 +159,7 @@
 bool operator<(const Mac8Address& a, const Mac8Address& b);
 
 /**
- * Address comparison, equalit.
+ * Address comparison, equality.
  *
  * \param a First address to compare.
  * \param b Second address to compare.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/utils/net-device-queue-interface.cc ns-3.38/src/network/utils/net-device-queue-interface.cc
--- ns-3.37/src/network/utils/net-device-queue-interface.cc	2022-11-01 17:37:24.695395700 -0700
+++ ns-3.38/src/network/utils/net-device-queue-interface.cc	2023-03-16 20:54:23.808869100 -0700
@@ -22,7 +22,6 @@
 #include "ns3/abort.h"
 #include "ns3/queue-item.h"
 #include "ns3/queue-limits.h"
-#include "ns3/simulator.h"
 #include "ns3/uinteger.h"
 
 namespace ns3
@@ -89,7 +88,7 @@
     // Request the queue disc to dequeue a packet
     if (wasStoppedByDevice && !m_wakeCallback.IsNull())
     {
-        Simulator::ScheduleNow(&NetDeviceQueue::m_wakeCallback, this);
+        m_wakeCallback();
     }
 }
 
@@ -142,7 +141,7 @@
     // Request the queue disc to dequeue a packet
     if (wasStoppedByQueueLimits && !m_wakeCallback.IsNull())
     {
-        Simulator::ScheduleNow(&NetDeviceQueue::m_wakeCallback, this);
+        m_wakeCallback();
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/utils/net-device-queue-interface.h ns-3.38/src/network/utils/net-device-queue-interface.h
--- ns-3.37/src/network/utils/net-device-queue-interface.h	2022-11-01 17:37:24.695395700 -0700
+++ ns-3.38/src/network/utils/net-device-queue-interface.h	2023-03-16 20:54:23.808869100 -0700
@@ -25,6 +25,7 @@
 #include "ns3/object-factory.h"
 #include "ns3/object.h"
 #include "ns3/ptr.h"
+#include "ns3/simulator.h"
 
 #include <functional>
 #include <vector>
@@ -361,19 +362,21 @@
 NetDeviceQueue::PacketDequeued(QueueType* queue, Ptr<const typename QueueType::ItemType> item)
 {
     NS_LOG_FUNCTION(this << queue << item);
-
-    // Inform BQL
-    NotifyTransmittedBytes(item->GetSize());
-
     NS_ASSERT_MSG(m_device, "Aggregated NetDevice not set");
-    // After dequeuing a packet, if there is room for another packet we
-    // call Wake () that ensures that the queue is not stopped and restarts
-    // the queue disc if the queue was stopped
 
-    if (!queue->WouldOverflow(1, m_device->GetMtu()))
-    {
-        Wake();
-    }
+    Simulator::ScheduleNow([=]() {
+        // Inform BQL
+        NotifyTransmittedBytes(item->GetSize());
+
+        // After dequeuing a packet, if there is room for another packet we
+        // call Wake () that ensures that the queue is not stopped and restarts
+        // the queue disc if the queue was stopped
+
+        if (!queue->WouldOverflow(1, m_device->GetMtu()))
+        {
+            Wake();
+        }
+    });
 }
 
 template <typename QueueType>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/utils/packet-socket.h ns-3.38/src/network/utils/packet-socket.h
--- ns-3.37/src/network/utils/packet-socket.h	2022-11-01 17:37:24.695395700 -0700
+++ ns-3.38/src/network/utils/packet-socket.h	2023-03-16 20:54:23.808869100 -0700
@@ -109,8 +109,8 @@
      */
     void SetNode(Ptr<Node> node);
 
-    enum SocketErrno GetErrno() const override;
-    enum SocketType GetSocketType() const override;
+    SocketErrno GetErrno() const override;
+    SocketType GetSocketType() const override;
     Ptr<Node> GetNode() const override;
     /**
      * \brief Bind the socket to the NetDevice and register the protocol handler.
@@ -196,15 +196,15 @@
         STATE_CLOSED
     };
 
-    Ptr<Node> m_node;                 //!< the associated node
-    mutable enum SocketErrno m_errno; //!< Socket error code
-    bool m_shutdownSend;              //!< Send no longer allowed
-    bool m_shutdownRecv;              //!< Receive no longer allowed
-    enum State m_state;               //!< Socket state
-    uint16_t m_protocol;              //!< Socket protocol
-    bool m_isSingleDevice;            //!< Is bound to a single netDevice
-    uint32_t m_device;                //!< index of the bound NetDevice
-    Address m_destAddr;               //!< Default destination address
+    Ptr<Node> m_node;            //!< the associated node
+    mutable SocketErrno m_errno; //!< Socket error code
+    bool m_shutdownSend;         //!< Send no longer allowed
+    bool m_shutdownRecv;         //!< Receive no longer allowed
+    State m_state;               //!< Socket state
+    uint16_t m_protocol;         //!< Socket protocol
+    bool m_isSingleDevice;       //!< Is bound to a single netDevice
+    uint32_t m_device;           //!< index of the bound NetDevice
+    Address m_destAddr;          //!< Default destination address
 
     std::queue<std::pair<Ptr<Packet>, Address>> m_deliveryQueue; //!< Rx queue
     uint32_t m_rxAvailable;                                      //!< Rx queue size [Bytes]
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/utils/pcap-file.h ns-3.38/src/network/utils/pcap-file.h
--- ns-3.37/src/network/utils/pcap-file.h	2022-11-01 17:37:24.695395700 -0700
+++ ns-3.38/src/network/utils/pcap-file.h	2023-03-16 20:54:23.808869100 -0700
@@ -296,7 +296,7 @@
     /**
      * \brief Pcap file header
      */
-    typedef struct
+    struct PcapFileHeader
     {
         uint32_t m_magicNumber; //!< Magic number identifying this as a pcap file
         uint16_t
@@ -307,18 +307,18 @@
         uint32_t m_sigFigs; //!< Unused by pretty much everybody
         uint32_t m_snapLen; //!< Maximum length of packet data stored in records
         uint32_t m_type;    //!< Data link type of packet data
-    } PcapFileHeader;
+    };
 
     /**
      * \brief Pcap record header
      */
-    typedef struct
+    struct PcapRecordHeader
     {
         uint32_t m_tsSec;   //!< seconds part of timestamp
         uint32_t m_tsUsec;  //!< microseconds part of timestamp (nsecs for PCAP_NSEC_MAGIC)
         uint32_t m_inclLen; //!< number of octets of packet saved in file
         uint32_t m_origLen; //!< actual length of original packet
-    } PcapRecordHeader;
+    };
 
     /**
      * \brief Swap a value byte order
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/utils/queue-size.h ns-3.38/src/network/utils/queue-size.h
--- ns-3.37/src/network/utils/queue-size.h	2022-11-01 17:37:24.695395700 -0700
+++ ns-3.38/src/network/utils/queue-size.h	2023-03-16 20:54:23.808869100 -0700
@@ -66,7 +66,7 @@
  * * A unit.
  *
  * Whitespace is allowed but not required between the numeric value and
- * multipler or unit.
+ * multiplier or unit.
  *
  * Supported multiplier prefixes:
  *
@@ -221,7 +221,8 @@
 ATTRIBUTE_HELPER_HEADER(QueueSize);
 
 /**
- * \brief Increase the queue size by a packet size
+ * Increase the queue size by a packet size, if the queue size is in bytes,
+ * or by one, otherwise.
  *
  * \param lhs queue size
  * \param rhs packet
@@ -230,7 +231,8 @@
 template <typename Item>
 QueueSize operator+(const QueueSize& lhs, const Ptr<Item>& rhs);
 /**
- * \brief Increase the queue size by a packet size
+ * Increase the queue size by a packet size, if the queue size is in bytes,
+ * or by one, otherwise.
  *
  * \param lhs packet
  * \param rhs queue size
@@ -240,6 +242,27 @@
 QueueSize operator+(const Ptr<Item>& lhs, const QueueSize& rhs);
 
 /**
+ * Decrease the queue size by a packet size, if the queue size is in bytes,
+ * or by one, otherwise.
+ *
+ * \param lhs queue size
+ * \param rhs packet
+ * \return the queue size decreased by the packet size
+ */
+template <typename Item>
+QueueSize operator-(const QueueSize& lhs, const Ptr<Item>& rhs);
+/**
+ * Decrease the queue size by a packet size, if the queue size is in bytes,
+ * or by one, otherwise.
+ *
+ * \param lhs packet
+ * \param rhs queue size
+ * \return the queue size decreased by the packet size
+ */
+template <typename Item>
+QueueSize operator-(const Ptr<Item>& lhs, const QueueSize& rhs);
+
+/**
  * Implementation of the templates declared above.
  */
 
@@ -272,6 +295,40 @@
     }
     NS_FATAL_ERROR("Unknown queue size mode");
 }
+
+template <typename Item>
+QueueSize
+operator-(const QueueSize& lhs, const Ptr<Item>& rhs)
+{
+    if (lhs.GetUnit() == QueueSizeUnit::PACKETS)
+    {
+        NS_ABORT_IF(lhs.GetValue() < 1);
+        return QueueSize(lhs.GetUnit(), lhs.GetValue() - 1);
+    }
+    if (lhs.GetUnit() == QueueSizeUnit::BYTES)
+    {
+        NS_ABORT_IF(lhs.GetValue() < rhs->GetSize());
+        return QueueSize(lhs.GetUnit(), lhs.GetValue() - rhs->GetSize());
+    }
+    NS_FATAL_ERROR("Unknown queue size mode");
+}
+
+template <typename Item>
+QueueSize
+operator-(const Ptr<Item>& lhs, const QueueSize& rhs)
+{
+    if (rhs.GetUnit() == QueueSizeUnit::PACKETS)
+    {
+        NS_ABORT_IF(rhs.GetValue() < 1);
+        return QueueSize(rhs.GetUnit(), rhs.GetValue() - 1);
+    }
+    if (rhs.GetUnit() == QueueSizeUnit::BYTES)
+    {
+        NS_ABORT_IF(rhs.GetValue() < lhs->GetSize());
+        return QueueSize(rhs.GetUnit(), rhs.GetValue() - lhs->GetSize());
+    }
+    NS_FATAL_ERROR("Unknown queue size mode");
+}
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/utils/sll-header.h ns-3.38/src/network/utils/sll-header.h
--- ns-3.37/src/network/utils/sll-header.h	2022-11-01 17:37:24.699395700 -0700
+++ ns-3.38/src/network/utils/sll-header.h	2023-03-16 20:54:23.812869000 -0700
@@ -101,7 +101,7 @@
     /**
      * \return Packet type
      */
-    enum PacketType GetPacketType() const;
+    PacketType GetPacketType() const;
 
     /**
      * \param type Depends on source and address of the packet
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/utils/timestamp-tag.cc ns-3.38/src/network/utils/timestamp-tag.cc
--- ns-3.37/src/network/utils/timestamp-tag.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/network/utils/timestamp-tag.cc	2023-03-16 20:54:23.812869000 -0700
@@ -0,0 +1,90 @@
+/*
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Joe Kopena <tjkopena@cs.drexel.edu>
+ */
+
+#include "timestamp-tag.h"
+
+#include "ns3/nstime.h"
+#include "ns3/tag-buffer.h"
+#include "ns3/tag.h"
+#include "ns3/type-id.h"
+#include "ns3/uinteger.h"
+
+namespace ns3
+{
+
+NS_OBJECT_ENSURE_REGISTERED(TimestampTag);
+
+TimestampTag::TimestampTag() = default;
+
+TimestampTag::TimestampTag(Time timestamp)
+    : m_timestamp(timestamp)
+{
+}
+
+TypeId
+TimestampTag::GetTypeId()
+{
+    static TypeId tid = TypeId("ns3::TimestampTag")
+                            .SetParent<Tag>()
+                            .SetGroupName("Network")
+                            .AddConstructor<TimestampTag>();
+    return tid;
+}
+
+TypeId
+TimestampTag::GetInstanceTypeId() const
+{
+    return GetTypeId();
+}
+
+uint32_t
+TimestampTag::GetSerializedSize() const
+{
+    return 8;
+}
+
+void
+TimestampTag::Serialize(TagBuffer i) const
+{
+    i.WriteU64(m_timestamp.GetTimeStep());
+}
+
+void
+TimestampTag::Deserialize(TagBuffer i)
+{
+    m_timestamp = TimeStep(i.ReadU64());
+}
+
+void
+TimestampTag::Print(std::ostream& os) const
+{
+    os << "timestamp=" << m_timestamp.As(Time::S);
+}
+
+Time
+TimestampTag::GetTimestamp() const
+{
+    return m_timestamp;
+}
+
+void
+TimestampTag::SetTimestamp(Time timestamp)
+{
+    m_timestamp = timestamp;
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/network/utils/timestamp-tag.h ns-3.38/src/network/utils/timestamp-tag.h
--- ns-3.37/src/network/utils/timestamp-tag.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/network/utils/timestamp-tag.h	2023-03-16 20:54:23.812869000 -0700
@@ -0,0 +1,82 @@
+/*
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Authors: Joe Kopena <tjkopena@cs.drexel.edu>
+ */
+
+#ifndef TIMESTAMP_TAG_H
+#define TIMESTAMP_TAG_H
+
+#include "ns3/nstime.h"
+#include "ns3/tag-buffer.h"
+#include "ns3/tag.h"
+#include "ns3/type-id.h"
+
+#include <iostream>
+
+namespace ns3
+{
+
+/**
+ * Timestamp tag for associating a timestamp with a packet.
+ *
+ * It would have been more realistic to include this info in
+ * a header. Here we show how to avoid the extra overhead in
+ * a simulation.
+ */
+class TimestampTag : public Tag
+{
+  public:
+    /**
+     * \brief Get the type ID.
+     * \return the object TypeId
+     */
+    static TypeId GetTypeId();
+    TypeId GetInstanceTypeId() const override;
+
+    /**
+     * \brief Construct a new TimestampTag object
+     */
+    TimestampTag();
+
+    /**
+     * \brief Construct a new TimestampTag object with the given timestamp
+     * \param timestamp The timestamp
+     */
+    TimestampTag(Time timestamp);
+
+    void Serialize(TagBuffer i) const override;
+    void Deserialize(TagBuffer i) override;
+    uint32_t GetSerializedSize() const override;
+    void Print(std::ostream& os) const override;
+
+    /**
+     * \brief Get the Timestamp object
+     * \return Time for this tag
+     */
+    Time GetTimestamp() const;
+
+    /**
+     * \brief Set the Timestamp object
+     * \param timestamp Timestamp to assign to tag
+     */
+    void SetTimestamp(Time timestamp);
+
+  private:
+    Time m_timestamp{0}; //!< Timestamp
+};
+
+} // namespace ns3
+
+#endif // TIMESTAMP_TAG_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/nix-vector-routing/CMakeLists.txt ns-3.38/src/nix-vector-routing/CMakeLists.txt
--- ns-3.37/src/nix-vector-routing/CMakeLists.txt	2022-11-01 17:37:24.699395700 -0700
+++ ns-3.38/src/nix-vector-routing/CMakeLists.txt	2023-03-16 20:54:23.812869000 -0700
@@ -4,8 +4,6 @@
                model/nix-vector-routing.cc
   HEADER_FILES helper/nix-vector-helper.h
                model/nix-vector-routing.h
-  DEPRECATED_HEADER_FILES helper/ipv4-nix-vector-helper.h
-                          model/ipv4-nix-vector-routing.h
   LIBRARIES_TO_LINK ${libinternet}
   TEST_SOURCES test/nix-test.cc
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/nix-vector-routing/examples/nix-simple.cc ns-3.38/src/nix-vector-routing/examples/nix-simple.cc
--- ns-3.37/src/nix-vector-routing/examples/nix-simple.cc	2022-11-01 17:37:24.699395700 -0700
+++ ns-3.38/src/nix-vector-routing/examples/nix-simple.cc	2023-03-16 20:54:23.812869000 -0700
@@ -255,7 +255,7 @@
                                       interfaces01.GetAddress(1),
                                       routingStream);
         // Trace routing tables
-        nixRouting.PrintRoutingTableAllAt(Seconds(8), routingStream);
+        Ipv4NixVectorHelper::PrintRoutingTableAllAt(Seconds(8), routingStream);
     }
     else
     {
@@ -302,7 +302,7 @@
                                       interfaces01.GetAddress(1, 1),
                                       routingStream);
         // Trace routing tables
-        nixRouting.PrintRoutingTableAllAt(Seconds(8), routingStream);
+        Ipv6NixVectorHelper::PrintRoutingTableAllAt(Seconds(8), routingStream);
     }
 
     UdpEchoServerHelper echoServer(9);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/nix-vector-routing/examples/nix-simple-multi-address.cc ns-3.38/src/nix-vector-routing/examples/nix-simple-multi-address.cc
--- ns-3.37/src/nix-vector-routing/examples/nix-simple-multi-address.cc	2022-11-01 17:37:24.699395700 -0700
+++ ns-3.38/src/nix-vector-routing/examples/nix-simple-multi-address.cc	2023-03-16 20:54:23.812869000 -0700
@@ -214,7 +214,7 @@
                                   interfaces12.GetAddress(1, 1),
                                   routingStream);
     // Trace routing tables.
-    nixRouting.PrintRoutingTableAllAt(Seconds(4), routingStream);
+    Ipv4NixVectorHelper::PrintRoutingTableAllAt(Seconds(4), routingStream);
     // Assign address5 addresses to n2 and n3.
     // n2 gets 10.2.3.1 and n3 gets 10.2.3.2 on the same interface.
     Simulator::Schedule(Seconds(5), &Ipv4AddressHelper::Assign, &address5, devices34);
@@ -223,7 +223,7 @@
     // Notice that NixCache and Ipv4RouteCache becomes empty for each node.
     // This happens because new addresses are added at t = +5s, due to which
     // existing caches get flushed.
-    nixRouting.PrintRoutingTableAllAt(Seconds(6), routingStream);
+    Ipv4NixVectorHelper::PrintRoutingTableAllAt(Seconds(6), routingStream);
 
     // Check the path from n0 to n3 (10.2.3.2).
     nixRouting.PrintRoutingPathAt(Seconds(7),
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/nix-vector-routing/model/nix-vector-routing.cc ns-3.38/src/nix-vector-routing/model/nix-vector-routing.cc
--- ns-3.37/src/nix-vector-routing/model/nix-vector-routing.cc	2022-11-01 17:37:24.699395700 -0700
+++ ns-3.38/src/nix-vector-routing/model/nix-vector-routing.cc	2023-03-16 20:54:23.812869000 -0700
@@ -1147,7 +1147,7 @@
     parentVector.at(source->GetId()) = source;
 
     // BFS loop
-    while (greyNodeList.size() != 0)
+    while (!greyNodeList.empty())
     {
         Ptr<Node> currNode = greyNodeList.front();
         Ptr<IpL3Protocol> ip = currNode->GetObject<IpL3Protocol>();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/nix-vector-routing/model/nix-vector-routing.h ns-3.38/src/nix-vector-routing/model/nix-vector-routing.h
--- ns-3.37/src/nix-vector-routing/model/nix-vector-routing.h	2022-11-01 17:37:24.699395700 -0700
+++ ns-3.38/src/nix-vector-routing/model/nix-vector-routing.h	2023-03-16 20:54:23.812869000 -0700
@@ -487,7 +487,7 @@
     static bool g_isCacheDirty;
 
     /**
-     * Nix Epoch, incremented each time a flush is perfomed.
+     * Nix Epoch, incremented each time a flush is performed.
      */
     static uint32_t g_epoch;
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/nix-vector-routing/test/nix-test.cc ns-3.38/src/nix-vector-routing/test/nix-test.cc
--- ns-3.37/src/nix-vector-routing/test/nix-test.cc	2022-11-01 17:37:24.699395700 -0700
+++ ns-3.38/src/nix-vector-routing/test/nix-test.cc	2023-03-16 20:54:23.812869000 -0700
@@ -297,8 +297,8 @@
     ifIndex = ipv6->GetInterfaceForDevice(dAdC.Get(0));
     Simulator::Schedule(Seconds(5), &Ipv6::SetDown, ipv6, ifIndex);
 
-    ipv4NixRouting.PrintRoutingTableAllAt(Seconds(7), cacheStreamv4);
-    ipv6NixRouting.PrintRoutingTableAllAt(Seconds(7), cacheStreamv6);
+    Ipv4NixVectorHelper::PrintRoutingTableAllAt(Seconds(7), cacheStreamv4);
+    Ipv6NixVectorHelper::PrintRoutingTableAllAt(Seconds(7), cacheStreamv6);
 
     SendData(Seconds(8), txSocket, Ipv4Address("10.1.3.2"));
     SendData(Seconds(8), txSocket, Ipv6Address("2001:3::200:ff:fe00:8"));
